
/* * * * * * * * * * * * * Author's note * * * * * * * * * * * *\
*   _       _   _       _   _       _   _       _     _ _ _ _   *
*  |_|     |_| |_|     |_| |_|_   _|_| |_|     |_|  _|_|_|_|_|  *
*  |_|_ _ _|_| |_|     |_| |_|_|_|_|_| |_|     |_| |_|_ _ _     *
*  |_|_|_|_|_| |_|     |_| |_| |_| |_| |_|     |_|   |_|_|_|_   *
*  |_|     |_| |_|_ _ _|_| |_|     |_| |_|_ _ _|_|  _ _ _ _|_|  *
*  |_|     |_|   |_|_|_|   |_|     |_|   |_|_|_|   |_|_|_|_|    *
*                                                               *
*                     http://www.humus.name                     *
*                                                                *
* This file is a part of the work done by Humus. You are free to   *
* use the code in any way you like, modified, unmodified or copied   *
* into your own work. However, I expect you to respect these points:  *
*  - If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  - For use in anything commercial, please request my approval.     *
*  - Share your work and ideas too as much as you can.             *
*                                                                *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "../Framework3/Direct3D10/D3D10App.h"

class App : public D3D10App
{
public:
	char *getTitle() const { return "Volume roads"; }

	void resetCamera();
	void moveCamera(const vec3 &dir);

	bool init();
	void exit();

	bool initAPI();
	void exitAPI();

	void onSize(const int w, const int h);
	bool onMouseButton(const int x, const int y, const MouseButton button, const bool pressed);

	bool load();
	void unload();

	void drawFrame();

protected:
	ShaderID m_TerrainShader, m_SkyboxShader, m_RoadShader, m_RoadStencilShader, m_ResolveDepthShader;
	TextureID m_Terrain, m_TerrainShadow, m_Ground0, m_Ground1, m_Road, m_Environment;
	TextureID m_DepthRT, m_DepthCopyRT;
	IndexBufferID m_BoxIB;

	Image m_TerrainImage;

	RasterizerStateID m_NoMSAA;
	DepthStateID m_StencilTag, m_StencilCull;
	SamplerStateID m_TrilinearClamp, m_TrilinearAniso;
	BlendStateID m_BlendMulAlpha;

	struct Road
	{
		Road(const float3 &pos0, const float3 &pos1)
		{
			m_Pos0 = pos0;
			m_Pos1 = pos1;
		}

		float3 m_Pos0;
		float3 m_Pos1;
	};

	Array<Road> m_Roads;

	bool m_MousePressed;

	float m_HelpDisplayTime;
};
